/****************************************** {COPYRIGHT-TOP} **
 * Aperi Storage Manager
 * (C) Copyright IBM Corp. 2006
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************* {COPYRIGHT-END} **/

package example.AgentRequestHandler.msg;

import java.util.Locale;
import java.util.ResourceBundle;

import org.eclipse.aperi.xmsg.IMessageBundleSource;
import org.eclipse.aperi.xmsg.MessageBundleManager;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExecutableExtension;
import org.eclipse.core.runtime.IExecutableExtensionFactory;

public class MessageBundleAdapter
    implements
        IMessageBundleSource,
        IExecutableExtension,
        IExecutableExtensionFactory {
    private String baseName;
    
    public ResourceBundle getResourceBundle(Locale locale) {
        ResourceBundle bundle = null;
        try {
            if (locale != null)
                bundle = ResourceBundle.getBundle(baseName, locale);
            else bundle = ResourceBundle.getBundle(baseName);
        } catch (Exception e) {
            // TODO Log exception?
        }
        
        return bundle;
    }

    public void dispose() {
        // Do nothing for now
        // Add code here if we ever need to do some sort of clean-up work
    }

    public void setInitializationData(
            IConfigurationElement config,
            String propertyName,
            Object data)
        throws CoreException {
        baseName = config.getAttribute(MessageBundleManager.ATTR_NAME);
    }

    public Object create() throws CoreException {
        return this;
    }
}
