package example.AgentRequestHandler.client;

import java.net.Socket;

import org.eclipse.aperi.connector.ConnectorClient;
import org.eclipse.aperi.constants.RequestType;
import org.eclipse.aperi.request.Request;
import org.eclipse.aperi.request.Response;
import org.eclipse.aperi.request.SocketTransceiver;
import org.eclipse.core.runtime.IPlatformRunnable;

public class Application implements IPlatformRunnable {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.IPlatformRunnable#run(java.lang.Object)
	 */
	public Object run(Object args) throws Exception {
		try{
			
			Request request = new Request();
			
			// RequestType.AGENT is used for all agent requests
			request.typeCode = RequestType.AGENT; 
			
			// The subType must match the value of the "id" attribute of
			// the plugin
			request.subType = "example.AgentRequestHandler.HelloWorld"; 
			
			// Connect to the Agent using the Connector Client
			Socket socket = ConnectorClient.getSocket(	
					"localhost", // Change if necessary
					9570, // Change if necessary
					"org.eclipse.aperi.agent.svp.SocketHandler"); // Used for all Data agent requests

			// Send the request to the agent and get a response
			SocketTransceiver socketTranceiver = new SocketTransceiver(socket);
			Response response = socketTranceiver.transmitRequest(request, null);
			
			if(response.status <= Response.WARNING)
			{
				System.out.println("Request completed successfully.");
			}else{
				if(response.errorMessage != null)
				{
					System.out.println("Request failed: " + response.errorMessage);
				}else{
					System.out.println("Request failed with status: " + response.status); 
				}
			}
			
		}catch(Throwable e)
		{
			e.printStackTrace();
		}
		return IPlatformRunnable.EXIT_OK;
	}
}
